/** ###################################################################
**     THIS BEAN MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename  : PPG1.C
**     Project   : DC18
**     Processor : MC56F8006_32_LQFP
**     Beantype  : PPG
**     Version   : Bean 02.177, Driver 02.00, CPU db: 3.00.169
**     Compiler  : Metrowerks DSP C Compiler
**     Date/Time : 8/1/2010, 4:32 AM
**     Abstract  :
**         This bean "PPG" implements a programmable
**         pulse generator that generates signal with variable
**         duty and variable cycle (period).
**     Settings  :
**         Used output pin             : 
**             ----------------------------------------------------
**                Number (on package)  |    Name
**             ----------------------------------------------------
**                       21            |  GPIOB0_ANB13_PWM3_SCLK_SCL_T1
**             ----------------------------------------------------
**
**         Timer name                  : TMR1 [16-bit]
**         Counter                     : TMR1_CNTR [61461]
**         Mode register               : TMR1_CTRL [61462]
**         Run register                : TMR1_CTRL [61462]
**         Prescaler                   : TMR1_CTRL [61462]
**         Compare 1 register          : TMR1_COMP1 [61456]
**         Compare 2 register          : TMR1_COMP2 [61457]
**         Comparator load 1 register  : TMR1_CMPLD1 [61464]
**         Comparator load 2 register  : TMR1_CMPLD2 [61465]
**         Flip-flop 1 register        : TMR1_SCTRL [61463]
**         Load register               : TMR1_LOAD [61459]
**
**         User handling procedure     : not specified
**
**         Output pin
**
**         Port name                   : GPIOB
**         Bit number (in port)        : 0
**         Bit mask of the port        : 1
**         Port data register          : GPIO_B_DR [61857]
**         Port control register       : GPIO_B_DDR [61858]
**         Port function register      : GPIO_B_PER [61859]
**
**         Runtime setting period      : interval (continual setting)
**             ticks                   : 134 to 400 ticks
**             microseconds            : 17 to 50 microseconds
**             Hz                      : 20000 to 59701 Hz
**             kHz                     : 20 to 59 kHz
**
**         Runtime setting ratio       : calculated
**         Initialization:
**              Output level           : high
**              Timer                  : Disabled
**              Event                  : Enabled
**         High speed mode
**             Prescaler               : divide-by-1
**             Clock                   : 4000000 Hz
**           Initial value of            period        pulse width (ratio 99.04%)
**             Xtal ticks              : 210           208
**             microseconds            : 26            26
**             seconds (real)          : 0.00002625    0.000026
**
**     Contents  :
**         Enable     - byte PPG1_Enable(void);
**         Disable    - byte PPG1_Disable(void);
**         SetFreqHz  - byte PPG1_SetFreqHz(word Freq);
**         SetRatio16 - byte PPG1_SetRatio16(word Ratio);
**         SetValue   - byte PPG1_SetValue(void);
**
**     (c) Copyright UNIS, a.s. 1997-2008
**     UNIS, a.s.
**     Jundrovska 33
**     624 00 Brno
**     Czech Republic
**     http      : www.processorexpert.com
**     mail      : info@processorexpert.com
** ###################################################################*/


/* MODULE PPG1. */

#include "PPG1.h"

static bool EnUser;                    /* Enable/Disable device by user */
static word RatioStore;                /* Ratio of L-level to H-level */
static word CmpDHigh;                  /* Duty register value for high speed CPU mode */
static word CmpPHigh;                  /* Period register value for high speed CPU mode */

/* Internal method prototypes */
static void HWEnDi(void);
static void SetRatio(void);
static void SetPV(byte Val);

/*
** ===================================================================
**     Method      :  SetPV (bean PPG)
**
**     Description :
**         Sets prescaler value. The method is called automatically as a 
**         part of several internal methods.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
static void SetPV(byte Val)
{
  setRegBitGroup(TMR1_CTRL,PCS,(8|Val)); /* Store given value to the prescaler */
}

/*
** ===================================================================
**     Method      :  HWEnDi (bean PPG)
**
**     Description :
**         Enables or disables the peripheral(s) associated with the bean.
**         The method is called automatically as a part of the Enable and 
**         Disable methods and several internal methods.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
static void HWEnDi(void)
{
  if (EnUser) {                        /* Enable device? */
    setRegBits(TMR1_CTRL,0x2000);      /* Run counter */
  }
  else {                               /* Disable device? */
    clrRegBit(TMR1_CTRL,CM0);          /* Stop counter */
    setRegBit(TMR1_SCTRL,FORCE);       /* Force output signal level */
    setReg(TMR1_CNTR,0);               /* Reset counter */
  }
}

/*
** ===================================================================
**     Method      :  SetRatio (bean PPG)
**
**     Description :
**         Calculates and sets new duty ratio. The method is called 
**         automatically as a part of several internal methods.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
static void SetRatio(void)
{
  CmpDHigh = (word)((CmpPHigh * (dword)RatioStore) >> 16); /* Calculate new value of duty register according to the given ratio for high speed CPU mode */
  setReg(TMR1_CMPLD1,CmpDHigh);        /* Set the pulse width of the off time, set CMPLD1 register in high speed mode */
  setReg(TMR1_CMPLD2,CmpPHigh - CmpDHigh); /* Set the pulse width of the on time, compare preload register setting  */
}

/*
** ===================================================================
**     Method      :  PPG1_Enable (bean PPG)
**
**     Description :
**         This method enables the signal generation 
**     Parameters  : None
**     Returns     :
**         ---        - Error code, possible codes:
**                           ERR_OK - OK
**                           ERR_SPEED - This device does not work in
**                           the active speed mode
** ===================================================================
*/
byte PPG1_Enable(void)
{
  if (!EnUser) {                       /* Is the device disabled by user? */
    EnUser = TRUE;                     /* If yes then set the flag "device enabled" */
    HWEnDi();                          /* Enable the device */

  }
  return ERR_OK;                       /* OK */
}

/*
** ===================================================================
**     Method      :  PPG1_Disable (bean PPG)
**
**     Description :
**         Disables the bean - it stops the signal generation and events calling.
**     Parameters  : None
**     Returns     :
**         ---        - Error code, possible codes:
**                           ERR_OK - OK
**                           ERR_SPEED - This device does not work in
**                           the active speed mode
** ===================================================================
*/
byte PPG1_Disable(void)
{
  if (EnUser) {                        /* Is the device enabled by user? */
    EnUser = FALSE;                    /* If yes then set the flag "device disabled" */
    HWEnDi();                          /* Disable the device */
  }
  return ERR_OK;                       /* OK */
}

/*
** ===================================================================
**     Method      :  PPG1_SetFreqHz (bean PPG)
**
**     Description :
**         This method sets the new frequency of the output signal. The
**         frequency is expressed in Hz as a 16-bit unsigned integer
**         number.
**         This method is only available when the runtime setting type
**         'from interval' is selected in the Timing dialog box of
**         the Runtime setting area.
**     Parameters  :
**         NAME       - DESCRIPTION
**         Freq       - Frequency to set [in Hz]
**                      (20000 to 59701 Hz)
**     Returns     :
**         ---        - Error code, possible codes:
**                           ERR_OK - OK
**                           ERR_SPEED - This device does not work in
**                           the active speed mode
**                           ERR_MATH - Overflow during evaluation
**                           ERR_RANGE - Parameter out of range
** ===================================================================
*/
byte PPG1_SetFreqHz(word Freq)
{
  dlong rtval;                         /* Result of two 32-bit numbers division */
  word rtword;                         /* Result of 64-bit number division */

  if ((Freq > (word)PPG1_SFREQ_HZ_MAX) || (Freq < (word)PPG1_SFREQ_HZ_MIN)) { /* Is the given value out of range? */
    return ERR_RANGE;                  /* If yes then error */
  }
  rtval[0] = 1024000000UL / Freq;      /* Divide high speed CPU mode coefficient by the given value */
  rtval[1] = 0;                        /* Convert result to the type dlong */
  if (PE_Timer_LngHi1(rtval[0],rtval[1],&rtword)) { /* Is the result greater or equal than 65536 ? */
    rtword = (word)65535U;             /* If yes then use maximal possible value */
  }
  if (rtword>1) {
    CmpPHigh = rtword - 2;             /* Store result (period register value for high speed CPU mode) to the variable CmpPHigh */
  }
  else {
    CmpPHigh = 0;
  }
  SetRatio();                          /* Calculate and set up new appropriate values of the duty and period registers */
  return ERR_OK;                       /* OK */
}

/*
** ===================================================================
**     Method      :  PPG1_SetRatio16 (bean PPG)
**
**     Description :
**         This method sets a new duty-cycle ratio.
**     Parameters  :
**         NAME       - DESCRIPTION
**         Ratio      - Ratio is expressed as an 16-bit unsigned integer
**                      number. 0 - 65535 value is proportional
**                      to ratio 0 - 100%
**         Note: Calculated duty depends on the timer possibilities
**               and on the selected period.
**     Returns     :
**         ---        - Error code, possible codes:
**                           ERR_OK - OK
**                           ERR_SPEED - This device does not work in
**                           the active speed mode
** ===================================================================
*/
byte PPG1_SetRatio16(word Ratio)
{
  RatioStore = Ratio;                  /* Store new value of the ratio */
  SetRatio();                          /* Calculate and set up new appropriate values of the duty and period registers */
  return ERR_OK;                       /* OK */
}

/*
** ===================================================================
**     Method      :  PPG1_SetValue (bean PPG)
**
**     Description :
**         This method sets (sets to "1" = "High") timer flip-flop
**         output signal level. It allow user to directly set the
**         output pin value (=flip-flop state), and can set the signal
**         polarity. This method only works when the timer is disabled
**         (Disable) otherwise it returns the error code. <ClrValue>
**         and <SetValue> methods are used for setting the initial
**         state.
**     Parameters  : None
**     Returns     :
**         ---             - Error code, possible codes:
**                           ERR_OK - OK
**                           ERR_SPEED - This device does not work in
**                           the active speed mode
**                           ERR_ENABLED - Bean is enabled. Bean must be
**                           disabled (see "Disable method")
** ===================================================================
*/
byte PPG1_SetValue(void)
{
  if (EnUser) {                        /* Is the device enabled by user? */
    return ERR_ENABLED;                /* If yes then error */
  }
  setRegBits(TMR1_SCTRL,2);            /* Set output signal level to high */
  return ERR_OK;                       /* OK */
}

/*
** ===================================================================
**     Method      :  PPG1_Init (bean PPG)
**
**     Description :
**         Initializes the associated peripheral(s) and the beans 
**         internal variables. The method is called automatically as a 
**         part of the application initialization code.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
void PPG1_Init(void)
{
  setReg(TMR1_LOAD,0);                 /* Clear load register */
  setReg(TMR1_CNTR,0);                 /* Clear counter */
  RatioStore = (word)64911U;           /* Store initial value of the ratio */
  CmpDHigh = (word)103U;               /* Duty - duty register value for high speed CPU mode */
  CmpPHigh = (word)103U;               /* Period - period register value for high speed CPU mode */
  /* TMR1_SCTRL: TCF=0,TCFIE=0,TOF=0,TOFIE=0,IEF=0,IEFIE=0,IPS=0,INPUT=0,CAPTURE_MODE=0,MSTR=0,EEOF=0,VAL=0,FORCE=1,OPS=1,OEN=1 */
  setReg(TMR1_SCTRL,7);                /* Set Status and Control Register */
  /* TMR1_CSCTRL: TCF2EN=0,TCF1EN=0,TCF2=0,TCF1=0,CL2=1,CL1=2 */
  setReg(TMR1_CSCTRL,6);               /* Set Comparator Status and Control Register */
  EnUser = FALSE;                      /* Disable device */
  setReg(TMR1_COMP1,CmpDHigh);         /* Set the pulse width of the off time, set CMP1 register in high speed CPU mode */
  setReg(TMR1_COMP2,CmpPHigh - CmpDHigh); /* Set the pulse width of the on time, set CMP2 register in high speed CPU mode */
  setReg(TMR1_CMPLD1,TMR1_COMP1);      /* Set the pulse width of the off time, set CMPLD1 register in high speed CPU mode */
  setReg(TMR1_CMPLD2,TMR1_COMP2);      /* Set the pulse width of the on time, set CMPLD2 register in high speed CPU mode */
  SetPV((byte)0);                      /* Set prescaler register according to the selected high speed CPU mode */
  /* TMR1_CTRL: CM=0,PCS=8,SCS=0,ONCE=0,LENGTH=1,DIR=0,Co_INIT=0,OM=4 */
  setRegBits(TMR1_CTRL,4132);          /* Set variable PWM mode and stop counter */
}

/* END PPG1. */

/*
** ###################################################################
**
**     This file was created by UNIS Processor Expert 2.99 [04.17]
**     for the Freescale 56800 series of microcontrollers.
**
** ###################################################################
*/
