
#ifndef __Delay10us_H
#define __Delay10us_H

/*Include shared modules, which are used for whole project*/
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
#include "assert.h"

/*lint -save -e???? Disable MISRA rule (all) checking. */
asm void Cpu_Delay10US(word us10);
/*
** ===================================================================
**     Method      :  Cpu_Delay10US (component 56F8006_32_LQFP)
**
**     Description :
**         This method realizes software delay. The length of delay
**         is at least 10 microsecond multiply input parameter
**         [us10]. As the delay implementation is not based on real
**         clock, the delay time may be increased by interrupt
**         service routines processed during the delay. Adding read
**         wait states for external program memory can cause delay
**         extension as well. The method is independent on selected
**         speed mode.
**     Parameters  :
**         NAME            - DESCRIPTION
**         us100           - Number of 10 us delay repetitions.
**     Returns     : Nothing
** ===================================================================
*/

/*lint -restore */

#endif	//__Delay10us_H