#include "codes.h"


// table of POWER codes
#define F_CPU  24000000L
#define TIMER_PRESCALE_VALUE  2
//#define freq_to_timerval(x) ((F_CPU / x - 1 ) / 2 / TIMER_PRESCALE_VALUE)
#define freq_to_timerval(x) (x)

// Code 000 -- Sony, Baur, Neckermann, Otto Versand, Palladium, Quelle, SEI, Sinudyne, Sonolor, Universum
__pmem const uint16_t sonyTimes[] =
{
	60,  60,
	120, 60,
	240, 60,
	60,  2759,
	60,  0,
	60,  2636,
	60,  2819,
};

__pmem const uint8_t sonyCodes[] = 
{
	0x21,
	0x01,
	0x01,
	0x00,
	0x10,
	0x00,
	0x32,
	0x10,
	0x10,
	0x10,
	0x01,
	0x00,
	0x04,
};   


__pmem const struct IrCode sonyCode =
{
	freq_to_timerval(40000),
	sonyTimes,
	sonyCodes
};

// Code 001 - Proscan, RCA, Curtis Mathes, Dimensia, GE, JC Penney, LXI, Radio Shack/Realistic, Sears, Wards
__pmem const uint16_t rcaTimes[] =
{
	52, 102,
	52, 205,
	411, 410,
	52, 821,
	52, 0,
};

__pmem const uint8_t rcaCodes[] = 
{
	0x21,
	0x11,
	0x10,
	0x01,
	0x01,
	0x01,
	0x00,
	0x00,
	0x01,
	0x10,
	0x10,
	0x10,
	0x13,
	0x21,
	0x11,
	0x10,
	0x01,
	0x01,
	0x01,
	0x00,
	0x00,
	0x01,
	0x10,
	0x10,
	0x10,
	0x14
};

__pmem const struct IrCode rcaCode =
{
	freq_to_timerval(55600),
	rcaTimes,
	rcaCodes
};

// Code 002 -- Panasonic
__pmem const uint16_t panasonicTimes[] =
{
	44, 45,
	44, 135,
	358, 180,
	44, 7720,
	44, 0,
};

__pmem const uint8_t panasonicCodes[] = 
{
	0x20,
	0x10,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x10,
	0x00,
	0x00,
	0x00,
	0x00,
	0x10,
	0x00,
	0x00,
	0x00,
	0x01,
	0x01,
	0x11,
	0x10,
	0x01,
	0x01,
	0x11,
	0x10,
	0x13,
	0x20,
	0x10,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x10,
	0x00,
	0x00,
	0x00,
	0x00,
	0x10,
	0x00,
	0x00,
	0x00,
	0x01,
	0x01,
	0x11,
	0x10,
	0x01,
	0x01,
	0x11,
	0x10,
	0x14
};

__pmem const struct IrCode panasonicCode = {
	freq_to_timerval(36130),
	panasonicTimes,
	panasonicCodes
};

// Code 003 -- Sharp
__pmem const uint16_t sharpTimes[] = 
{
	29, 81,
	29, 189,
	29, 4670,
	29, 0,
};

__pmem const uint8_t sharpCodes[] = 
{
	0x10,
	0x00,
	0x00,
	0x11,
	0x01,
	0x00,
	0x01,
	0x02,
	0x10,
	0x00,
	0x01,
	0x00,
	0x10,
	0x11,
	0x10,
	0x12,
	0x10,
	0x00,
	0x00,
	0x11,
	0x01,
	0x00,
	0x01,
	0x02,
	0x10,
	0x00,
	0x01,
	0x00,
	0x10,
	0x11,
	0x10,
	0x13
};

__pmem const struct IrCode sharpCode = 
{
	freq_to_timerval(37470),
	sharpTimes,
	sharpCodes	
};

// Code 004 -- Toshiba, Apex
__pmem const uint16_t toshibaTimes[] = 
{
	58, 57,
	58, 173,
	926, 230,
	924, 464,
	58, 4054,
	58, 9880,
	58, 0,
};

__pmem const uint8_t toshibaCodes[] = 
{
	0x30,
	0x00,
	0x00,
	0x01,
	0x01,
	0x11,
	0x11,
	0x10,
	0x10,
	0x10,
	0x01,
	0x00,
	0x01,
	0x01,
	0x10,
	0x11,
	0x14,
	0x25,
	0x26
};

__pmem const struct IrCode toshibaCode = 
{
	freq_to_timerval(37470),
	toshibaTimes,
	toshibaCodes
};

// Code 005 -- Philips, Grundig, Pye
__pmem const uint16_t philipsTimes[] = 
{
	89,  89,
	178, 89,
	89,  178,
	89,  9216,
	89,  0,
	178, 9216,
	178, 0
};

__pmem const uint8_t philipsCodes[] = 
{
	0x01,
	0x00,
	0x00,
	0x00,
	0x20,
	0x13,
	0x01,
	0x00,
	0x00,
	0x00,
	0x20,
	0x14
};

__pmem const struct IrCode philipsCode = 
{
	freq_to_timerval(36000),
	philipsTimes,
	philipsCodes
};

// Code 006 -- Samsung
__pmem const uint16_t samsungTimes[] = 
{
	53, 62,
	53, 175,
	464, 476,
	53, 4661,
	53, 0,
};

__pmem const uint8_t samsungCodes[] = 
{
	0x21,
	0x11,
	0x00,
	0x00,
	0x01,
	0x11,
	0x00,
	0x00,
	0x00,
	0x10,
	0x00,
	0x00,
	0x01,
	0x01,
	0x11,
	0x11,
	0x13,
	0x21,
	0x11,
	0x00,
	0x00,
	0x01,
	0x11,
	0x00,
	0x00,
	0x00,
	0x10,
	0x00,
	0x00,
	0x01,
	0x01,
	0x11,
	0x11,
	0x14
};


__pmem const struct IrCode samsungCode = 
{
	freq_to_timerval(37470),
	samsungTimes,
	samsungCodes
};

// Code 007 -- Zenith
__pmem const uint16_t zenithTimes[] = 
{
	52, 49,
	52, 419,
	52, 522,
	52, 12433,
	52, 0,
	52, 12922,
	51, 10746,
};

__pmem const uint8_t zenithCodes[] = 
{
	0x01,
	0x20,
	0x10,
	0x12,
	0x01,
	0x20,
	0x12,
	0x20,
	0x30,
	0x12,
	0x01,
	0x01,
	0x20,
	0x12,
	0x01,
	0x22,
	0x04
};

__pmem const struct IrCode zenithCode = 
{
	freq_to_timerval(40300),
	zenithTimes,
	zenithCodes
};

// Code 008 --Pioneer, Sansui, Toshiba
__pmem const uint16_t pioneerTimes[] = 
{
	59, 59,
	59, 173,
	926, 461,
	59, 4117,
	59, 0,
};

__pmem const uint8_t pioneerCodes[] = 
{
	0x21,
	0x00,
	0x01,
	0x11,
	0x00,
	0x11,
	0x10,
	0x00,
	0x10,
	0x10,
	0x10,
	0x01,
	0x01,
	0x01,
	0x01,
	0x10,
	0x13,
	0x21,
	0x00,
	0x01,
	0x11,
	0x00,
	0x11,
	0x10,
	0x00,
	0x10,
	0x10,
	0x10,
	0x01,
	0x01,
	0x01,
	0x01,
	0x10,
	0x14
};

__pmem const struct IrCode pioneerCode = 
{
	freq_to_timerval(37470),
	pioneerTimes,
	pioneerCodes	
};

// Code 009 -- Sylvania
__pmem const uint16_t sylvaniaTimes[] = 
{
	56, 56,
	56, 174,
	926, 230,
	924, 461,
	56, 4055,
	56, 9855,
	56, 0,
};

__pmem const uint8_t sylvaniaCodes[] =
{
	0x31,
	0x11,
	0x00,
	0x00,
	0x10,
	0x10,
	0x00,
	0x10,
	0x00,
	0x00,
	0x00,
	0x11,
	0x11,
	0x11,
	0x11,
	0x00,
	0x04,
	0x25,
	0x26
};

__pmem const struct IrCode sylvaniaCode = {
	freq_to_timerval(37430),
	sylvaniaTimes,
	sylvaniaCodes
};

// Code 010 -- JVC
__pmem const uint16_t jvcTimes[] = 
{
	53, 55,
	53, 161,
	865, 429,
	53, 2347,
	53, 0,
};

__pmem const uint8_t jvcCodes[] = 
{
	0x21,
	0x10,
	0x00,
	0x00,
	0x01,
	0x11,
	0x01,
	0x00,
	0x03,
	0x11,
	0x00,
	0x00,
	0x00,
	0x11,
	0x10,
	0x10,
	0x00,
	0x31,
	0x10,
	0x00,
	0x00,
	0x01,
	0x11,
	0x01,
	0x00,
	0x04,
};

__pmem const struct IrCode jvcCode = 
{
	freq_to_timerval(37470),
	jvcTimes,
	jvcCodes
};

// Code 011 -- Hitachi
__pmem const uint16_t hitachiTimes[] = 
{
	58, 55,
	58, 175,
	910, 229,
	909, 452,
	58, 4146,
	58, 9597,
	56, 0,
};

__pmem const uint8_t hitachiCodes[] =
{
	0x30,
	0x00,
	0x01,
	0x01,
	0x01,
	0x11,
	0x10,
	0x10,
	0x11,
	0x11,
	0x01,
	0x00,
	0x00,
	0x00,
	0x10,
	0x11,
	0x14,
	0x25,
	0x26
};
   
__pmem const struct IrCode hitachiCode = 
{
	freq_to_timerval(37470),
	hitachiTimes,
	hitachiCodes
};

// Code 012 -- Sampo
__pmem const uint16_t sampoTimes[] =
{
	85, 87,
	85, 260,
	342, 344,
	85, 3366,
	85, 0,
};

__pmem const uint8_t sampoCodes[] = 
{
	0x21,
	0x01,
	0x10,
	0x10,
	0x11,
	0x00,
	0x00,
	0x10,
	0x10,
	0x01,
	0x00,
	0x11,
	0x13,
	0x21,
	0x01,
	0x10,
	0x10,
	0x11,
	0x00,
	0x00,
	0x10,
	0x10,
	0x01,
	0x00,
	0x11,
	0x14
};

__pmem const struct IrCode sampoCode = 
{
	freq_to_timerval(37470),
	sampoTimes,
	sampoCodes
};

// Code 013 -- Hisense
__pmem const uint16_t hisenseTimes[] = 
{
	56, 55,
	56, 170,
	920, 458,
	56, 2364,
	56, 9620,
	56, 0,
};

__pmem const uint8_t hisenseCodes[] = 
{
	0x20,
	0x01,
	0x11,
	0x00,
	0x01,
	0x00,
	0x00,
	0x11,
	0x00,
	0x01,
	0x11,
	0x01,
	0x11,
	0x10,
	0x10,
	0x01,
	0x00,
	0x01,
	0x01,
	0x10,
	0x11,
	0x13,
	0x24,
	0x25
};

__pmem const struct IrCode hisenseCode = 
{
	freq_to_timerval(37520),
	hisenseTimes,
	hisenseCodes
};

// Code 014 -- Viewsonic, Acer
__pmem const uint16_t viewsonicTimes[] = 
{
	58, 57,
	58, 173,
	926, 230,
	924, 464,
	58, 4054,
	58, 9880,
	58, 0,
};

__pmem const uint8_t viewsonicCodes[] = 
{
	0x30,
	0x00,
	0x00,
	0x11,
	0x01,
	0x11,
	0x11,
	0x00,
	0x11,
	0x10,
	0x00,
	0x00,
	0x00,
	0x01,
	0x11,
	0x11,
	0x14,
	0x25,
	0x26
};
	
__pmem const struct IrCode viewsonicCode = 
{
	freq_to_timerval(37470),
	viewsonicTimes,
	viewsonicCodes
};

// Code 015 -- Bush, NET-TV
__pmem const uint16_t bushTimes[] = 
{
	58, 57,
	58, 173,
	926, 230,
	924, 464,
	58, 4054,
	58, 9880,
	58, 0,
};

__pmem const uint8_t bushCodes[] = 
{
	0x30,
	0x10,
	0x00,
	0x01,
	0x01,
	0x01,
	0x11,
	0x10,
	0x11,
	0x00,
	0x00,
	0x00,
	0x00,
	0x11,
	0x11,
	0x11,
	0x14,
	0x25,
	0x26
};

__pmem const struct IrCode bushCode = 
{
	freq_to_timerval(37470),
	bushTimes,
	bushCodes
};

// Code 016 -- AOC, Daewoo, Goldstar, JC Penney, LG, Memorex, MGA, 
// Mistubishi, MTC, NEC, Philco, Portland, RCA, Samsung, 
// Teknika, Vidtech, Wards, Yamaha
__pmem const uint16_t aocTimes[] = 
{
	30, 91,
	30, 216,
	30, 2573,
	30, 0,
};

__pmem const uint8_t aocCodes[] =
{
	0x11,
	0x10,
	0x00,
	0x10,
	0x01,
	0x00,
	0x00,
	0x00,
	0x21,
	0x11,
	0x00,
	0x01,
	0x00,
	0x10,
	0x00,
	0x00,
	0x03
};

__pmem const struct IrCode aocCode = 
{
	freq_to_timerval(33600),
	aocTimes,
	aocCodes
};

// Code 017 -- Bell & Howell, Curtis Mathes, Emerson, Fisher, LXI, Memorex, 
// Radio Shack, Realistic, Sanyo, Sears, Toshiba
__pmem const uint16_t bellTimes[] = 
{
	59, 57,
	59, 178,
	924, 231,
	924, 459,
	59, 4260,
	59, 9753,
	59, 0,
};

__pmem const uint8_t bellCodes[] = 
{
	0x30,
	0x00,
	0x11,
	0x10,
	0x01,
	0x11,
	0x00,
	0x01,
	0x10,
	0x10,
	0x01,
	0x00,
	0x01,
	0x01,
	0x10,
	0x11,
	0x14,
	0x25,
	0x26
};

__pmem const struct IrCode bellCode = 
{
	freq_to_timerval(38970),
	bellTimes,
	bellCodes
};

// Code 018 -- Pioneer, Hitachi
__pmem const uint16_t pioneer2Times[] = 
{
	53, 55,
	53, 164,
	873, 440,
	53, 2633,
	53, 0,
};

__pmem const uint8_t pioneer2Codes[] =	
{
	0x20,
	0x10,
	0x10,
	0x10,
	0x11,
	0x01,
	0x01,
	0x01,
	0x00,
	0x01,
	0x11,
	0x00,
	0x01,
	0x10,
	0x00,
	0x11,
	0x13,
	0x20,
	0x10,
	0x10,
	0x10,
	0x11,
	0x01,
	0x01,
	0x01,
	0x00,
	0x01,
	0x11,
	0x00,
	0x01,
	0x10,
	0x00,
	0x11,
	0x13,
	0x20,
	0x10,
	0x10,
	0x10,
	0x11,
	0x01,
	0x01,
	0x01,
	0x00,
	0x01,
	0x11,
	0x00,
	0x01,
	0x10,
	0x00,
	0x14
};

__pmem const struct IrCode pioneer2Code = 
{
	freq_to_timerval(37470),
	pioneer2Times,
	pioneer2Codes	
};

// Code 019 -- Fujitsu
__pmem const uint16_t fujitsuTimes[] = 
{
	43, 42,
	43, 126,
	336, 166,
	43, 4723,
	43, 0,
};

__pmem const uint8_t fujitsuCodes[] =
{
	0x20,
	0x01,
	0x01,
	0x00,
	0x01,
	0x10,
	0x00,
	0x11,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x01,
	0x00,
	0x00,
	0x10,
	0x01,
	0x00,
	0x00,
	0x10,
	0x10,
	0x00,
	0x00,
	0x03,
	0x20,
	0x01,
	0x01,
	0x00,
	0x01,
	0x10,
	0x00,
	0x11,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x01,
	0x00,
	0x00,
	0x10,
	0x01,
	0x00,
	0x00,
	0x10,
	0x10,
	0x00,
	0x00,
	0x04
};

__pmem const struct IrCode fujitsuCode = 
{
	freq_to_timerval(37470),
	fujitsuTimes,
	fujitsuCodes
};

// Code 020 - Gold Star, JC Penney, LXI, Marantz, Memorex, Proton, Pulsar, 
// Toshiba, Wards
__pmem const uint16_t goldstarTimes[] = 
{
	63, 55,
	63, 166,
	926, 234,
	924, 472,
	63, 4207,
	63, 9957,
	62, 0,
};

__pmem const uint8_t goldstarCodes[] =
{
	0x30,
	0x01,
	0x00,
	0x00,
	0x01,
	0x10,
	0x11,
	0x11,
	0x10,
	0x00,
	0x10,
	0x00,
	0x01,
	0x11,
	0x01,
	0x11,
	0x14,
	0x25,
	0x26
};

__pmem const struct IrCode goldstarCode = 
{
	freq_to_timerval(37470),
	goldstarTimes,
	goldstarCodes
};

// Code 021 - Daewoo, Emerson, Hitachi, RCA, White Westinghouse, Zenith
__pmem const uint16_t daewooTimes[] = 
{
	51, 52,
	51, 163,
	51, 409,
	822, 409,
	51, 2397,
	51, 0,
};

__pmem const uint8_t daewooCodes[] =
{
	0x30,
	0x01,
	0x01,
	0x00,
	0x02,
	0x10,
	0x10,
	0x10,
	0x00,
	0x43,
	0x00,
	0x10,
	0x10,
	0x00,
	0x21,
	0x01,
	0x01,
	0x00,
	0x05,
};

__pmem const struct IrCode daewooCode = 
{
	freq_to_timerval(37470),
	daewooTimes,
	daewooCodes
};

// Code 022 - NEC
__pmem const uint16_t NECTimes[] = 
{
	56, 61,
	56, 179,
	921, 230,
	918, 460,
	56, 4581,
	56, 9705,
	56, 0,
};

__pmem const uint8_t NECCodes[] = 
{
	0x30,
	0x00,
	0x11,
	0x00,
	0x00,
	0x00,
	0x11,
	0x00,
	0x00,
	0x00,
	0x00,
	0x01,
	0x11,
	0x11,
	0x11,
	0x10,
	0x04,
	0x25,
	0x26,
};

__pmem const struct IrCode NECCode = 
{
	freq_to_timerval(37470),
	NECTimes,
	NECCodes
};

// Code 023 - Admiral, Bell & Howell, Logik, Majestic, Memorex, 
// Montgomery Ward, Signature, Teknika, Wards, Zenith

__pmem const uint8_t admiralCodes[] =
{
	0x22,
	0x01,
	0x01,
	0x20,
	0x12,
	0x01,
	0x22,
	0x01,
	0x01,
	0x20,
	0x16,
	0x22,
	0x01,
	0x01,
	0x20,
	0x12,
	0x01,
	0x22,
	0x01,
	0x01,
	0x20,
	0x14,
};

__pmem const struct IrCode admiralCode = 
{
	freq_to_timerval(40300),
	zenithTimes,
	admiralCodes   
};

// Code 024 - Sony
__pmem const uint8_t sony2Codes[] =
{
	0x21,
	0x11,
	0x10,
	0x10,
	0x10,
	0x00,
	0x52,
	0x11,
	0x11,
	0x01,
	0x01,
	0x00,
	0x04,
};

__pmem const struct IrCode sony2Code = 
{
	freq_to_timerval(40000),
	sonyTimes,
	sony2Codes
};

// Code 025 - Viewsonic, Magnavox, NET-TV, Electrograph, Gateway, Maxent, 
// NetTV, Sampo
__pmem const uint16_t viewsonic2Times[] = 
{
	88, 91,
	88, 270,
	358, 358,
	88, 3562,
	88, 0,
};

__pmem const uint8_t viewsonic2Codes[] =
{
	0x21,
	0x11,
	0x11,
	0x11,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x11,
	0x11,
	0x13,
	0x21,
	0x11,
	0x11,
	0x11,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x11,
	0x11,
	0x14,
};

__pmem const struct IrCode viewsonic2Code = 
{
	freq_to_timerval(37470),
	viewsonic2Times,
	viewsonic2Codes
};

// Code 026 - Zenith
__pmem const uint8_t zenith2Codes[] =
{
	0x01,
	0x20,
	0x10,
	0x12,
	0x20,
	0x12,
	0x01,
	0x20,
	0x50,
	0x12,
	0x01,
	0x01,
	0x22,
	0x01,
	0x20,
	0x12,
	0x04,
};

__pmem const struct IrCode zenith2Code = 
{
	freq_to_timerval(40300),
	zenithTimes,
	zenith2Codes
};

// Code 027 - Thompson
__pmem const uint16_t thompsonTimes[] = 
{
	52, 102,
	52, 205,
	411, 410,
	52, 821,
	51, 0,
};

__pmem const uint8_t thompsonCodes[] =
{
	0x20,
	0x11,
	0x10,
	0x01,
	0x01,
	0x01,
	0x01,
	0x00,
	0x01,
	0x10,
	0x10,
	0x10,
	0x13,
	0x20,
	0x11,
	0x10,
	0x01,
	0x01,
	0x01,
	0x01,
	0x00,
	0x01,
	0x10,
	0x10,
	0x10,
	0x14,
};

__pmem const struct IrCode thompsonCode = 
{
	freq_to_timerval(55600),
	thompsonTimes,
	thompsonCodes
};

// Code 028  - Brillian, Sears
__pmem const uint16_t brillianTimes[] = 
{
	123, 123,
	123, 277,
	267, 277,
	123, 4876,
	123, 0,
};

__pmem const uint8_t brillianCodes[] =
{
	0x20,
	0x10,
	0x10,
	0x11,
	0x01,
	0x10,
	0x00,
	0x10,
	0x13,
	0x20,
	0x10,
	0x10,
	0x11,
	0x01,
	0x10,
	0x00,
	0x10,
	0x14,
};

__pmem const struct IrCode brillianCode = 
{
	freq_to_timerval(37430),
	brillianTimes,
	brillianCodes
};

// Code 029 - Magnavox
__pmem const uint8_t magnavoxCodes[] =
{
	0x01,
	0x00,
	0x00,
	0x21,
	0x20,
	0x50,
	0x10,
	0x00,
	0x02,
	0x12,
	0x06,
};
	
__pmem const struct IrCode magnavoxCode = 
{
	freq_to_timerval(36000),
	philipsTimes,
	magnavoxCodes
};

// Code 030 - Viewsonic
__pmem const uint16_t viewsonic3Times[] = 
{
	56, 56,
	56, 174,
	926, 230,
	924, 461,
	56, 4055,
	56, 9855,
	56, 0,
};

__pmem const uint8_t viewsonic3Codes[] =
{
	0x30,
	0x00,
	0x01,
	0x01,
	0x01,
	0x01,
	0x10,
	0x10,
	0x10,
	0x00,
	0x00,
	0x00,
	0x01,
	0x11,
	0x11,
	0x11,
	0x14,
	0x25,
	0x26,
};
	
__pmem const struct IrCode viewsonic3Code = 
{
	freq_to_timerval(37470),
	viewsonic3Times,
	viewsonic3Codes
};

// Code 031 - Crown, Infinity, JBL, Loewe, LXI, Magnavox, Marantz, 
// Panaxonic, Philco, Philips, Sylvania, Wards
__pmem const uint8_t crownCodes[] = 
{
	0x00,
	0x10,
	0x00,
	0x00,
	0x20,
	0x13,
	0x00,
	0x10,
	0x00,
	0x00,
	0x20,
	0x14,
};

__pmem const struct IrCode crownCode = 
{
	freq_to_timerval(34800),
	philipsTimes,
	crownCodes	
};

// Code 032 - Hitachi

__pmem const uint8_t hitachi2Codes[] =
{
	0x30,
	0x00,
	0x01,
	0x01,
	0x01,
	0x01,
	0x10,
	0x10,
	0x10,
	0x10,
	0x00,
	0x00,
	0x01,
	0x01,
	0x11,
	0x11,
	0x14,
	0x25,
	0x26,
};

__pmem const struct IrCode hitachi2Code = 
{
	freq_to_timerval(37470),
	viewsonic3Times,
	hitachi2Codes
};

// Code 033 - Fujitsu
__pmem const uint16_t fujitsu2Times[] = 
{
	43, 43,
	43, 124,
	346, 158,
	43, 5438,
	43, 0,
};

__pmem const uint8_t fujitsu2Codes[] = 
{
	0x20,
	0x01,
	0x01,
	0x00,
	0x01,
	0x10,
	0x00,
	0x11,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x01,
	0x00,
	0x00,
	0x10,
	0x10,
	0x10,
	0x00,
	0x10,
	0x00,
	0x00,
	0x00,
	0x03,
	0x20,
	0x01,
	0x01,
	0x00,
	0x01,
	0x10,
	0x00,
	0x11,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x01,
	0x00,
	0x00,
	0x10,
	0x10,
	0x10,
	0x00,
	0x10,
	0x00,
	0x00,
	0x00,
	0x04,
};

__pmem const struct IrCode fujitsu2Code = 
{
	freq_to_timerval(37470),
	fujitsu2Times,
	fujitsu2Codes
};

// Code 034 - Hitachi
__pmem const uint16_t hitachi3Times[] = 
{
	58, 57,
	58, 173,
	925, 230,
	924, 464,
	58, 4054,
	58, 9880,
	58, 0,
};

__pmem const uint8_t hitachi3Codes[] =
{
	0x30,
	0x00,
	0x01,
	0x01,
	0x01,
	0x11,
	0x10,
	0x10,
	0x11,
	0x11,
	0x11,
	0x10,
	0x00,
	0x00,
	0x00,
	0x01,
	0x14,
	0x25,
	0x26,
};

__pmem const struct IrCode hitachi3Code = 
{
	freq_to_timerval(37470),
	hitachi3Times,
	hitachi3Codes
};

// Code 035 - NEC
__pmem const uint16_t NEC2Times[] = 
{
	58, 57,
	58, 173,
	926, 230,
	924, 464,
	58, 4054,
	58, 9880,
	58, 0,
};


__pmem const uint8_t NEC2Codes[] =
{
	0x30,
	0x00,
	0x11,
	0x00,
	0x01,
	0x11,
	0x00,
	0x11,
	0x10,
	0x00,
	0x10,
	0x00,
	0x01,
	0x11,
	0x01,
	0x11,
	0x14,
	0x25,
	0x26,
};

__pmem const struct IrCode NEC2Code = 
{
	freq_to_timerval(37470),
	NEC2Times,
	NEC2Codes	
};

// Code 036 - Hitachi
__pmem const uint16_t hitachi4Times[] =
{
	101, 94,
	101, 293,
	101, 3522,
	101, 0,
};

__pmem const uint8_t hitachi4Codes[] =
{
	0x00,
	0x01,
	0x01,
	0x01,
	0x00,
	0x20,
	0x00,
	0x10,
	0x10,
	0x10,
	0x03,
};

__pmem const struct IrCode hitachi4Code =
{
	freq_to_timerval(40580),
	hitachi4Times,
	hitachi4Codes	
};

// Code 037 - Anam National, Electrohome, GE, Motorola, NEC, Panasonic, 
// Philco, Philips, Quasar, RCA, Tatung
__pmem const uint16_t anamTimes[] = 
{
	88, 255,
	88, 594,
	88, 0,
};

__pmem const uint8_t anamCodes[] =
{
	0x10,
	0x00,
	0x10,
	0x11,
	0x10,
	0x20
};

__pmem const struct IrCode anamCode = 
{
	freq_to_timerval(36090),
	anamTimes,
	anamCodes	
};

// Code 038 - AOC, NEC
__pmem const uint16_t aoc2Times[] = 
{
	170, 166,
	530, 167,
	42, 269,
	42, 0,
};

__pmem const uint8_t aoc2Codes[] =
{
	0x12,
	0x22,
	0x02,
	0x00,
	0x22,
	0x30
};
	
__pmem const struct IrCode aoc2Code = 
{
	freq_to_timerval(40580),
	aoc2Times,
	aoc2Codes
};

// Code 039 - Candle, Citizen, JC Penney, Magnavox, Philco, Philips, 
// Simpson, Soundesign, Sylvania, Teknika
__pmem const uint16_t candleTimes[] = 
{
	59, 57,
	59, 178,
	924, 231,
	924, 459,
	59, 4262,
	59, 9758,
	59, 0,
};

__pmem const uint8_t candleCodes[] =
{
	0x31,
	0x01,
	0x01,
	0x00,
	0x00,
	0x10,
	0x10,
	0x11,
	0x10,
	0x10,
	0x01,
	0x00,
	0x01,
	0x01,
	0x10,
	0x11,
	0x14,
	0x25,
	0x26,
};

__pmem const struct IrCode candleCode = 
{
	freq_to_timerval(38970),
	candleTimes,
	candleCodes	
};

// Code 040 - Contec/Cony, Emerson, Goldstar, Hitachi, JVC, Philco,
// Philips, Proton, Radio Shack/Realistic, Samsung, Scott,
// Sharp, Teknika
__pmem const uint16_t contecTimes[] = 
{
	118, 103,
	708, 2778,
	708, 0,
};

__pmem const uint8_t contecCodes[] =
{
	0x01,
	0x02,
};

__pmem const struct IrCode contecCode = 
{
	freq_to_timerval(54070),
	contecTimes,
	contecCodes
};

// Code 041 - Contec/Cony, Hitachi, JC Penney, JVC, Sears, Teknika
__pmem const uint16_t contec2Times[] = 
{
	118, 103,
	118, 205,
	118, 2778,
	118, 0,
};

__pmem const uint8_t contec2Codes[] =
{
	0x00,
	0x12,
	0x00,
	0x13,
};

__pmem const struct IrCode contec2Code = 
{
	freq_to_timerval(38970),
	contec2Times,
	contec2Codes
};

// Code 042 - Sony
__pmem const uint8_t sony3Codes[] =
{
	0x21,
	0x01,
	0x01,
	0x00,
	0x10,
	0x00,
	0x62,
	0x10,
	0x10,
	0x10,
	0x01,
	0x00,
	0x04,
};

__pmem const struct IrCode sony3Code = 
{
	freq_to_timerval(40000),
	sonyTimes,
	sony3Codes
};

// Code 043 - Alleron, Emerson, Fujitsu, Funai, Grunpy, Scott, Sears, 
// Soundesign, Teknika, Wards
__pmem const uint16_t alleronTimes[] = 
{
	56, 66,
	56, 173,
	924, 231,
	924, 431,
	56, 4208,
	56, 8899,
	56, 0,
};

__pmem const uint8_t alleronCodes[] =
{
	0x31,
	0x10,
	0x00,
	0x00,
	0x10,
	0x10,
	0x11,
	0x11,
	0x00,
	0x00,
	0x10,
	0x00,
	0x01,
	0x11,
	0x01,
	0x11,
	0x14,
	0x25,
	0x26,
};

__pmem const struct IrCode alleronCode = 
{
	freq_to_timerval(38970),
	alleronTimes,
	alleronCodes
};

// Code 044 - Contec/Cony, Hitachi, JVC, Sears, Teknika
__pmem const uint16_t contec3Times[] = 
{
	136, 45,
	46, 123,
	46, 3583,
	46, 0,
};

__pmem const uint8_t contec3Codes[] =
{
	0x11,
	0x11,
	0x10,
	0x11,
	0x11,
	0x12,
	0x11,
	0x11,
	0x10,
	0x11,
	0x11,
	0x13,
};

__pmem const struct IrCode contec3Code = 
{
	freq_to_timerval(39010),
	contec3Times,
	contec3Codes
};

// Code 045 - Curtis Mathes, Samsung
__pmem const uint16_t curtisTimes[] = 
{
	54, 51,
	54, 163,
	908, 224,
	444, 446,
	54, 4204,
	54, 9767,
	54, 0,
};

__pmem const uint8_t curtisCodes[] =
{
	0x31,
	0x11,
	0x00,
	0x00,
	0x00,
	0x00,
	0x11,
	0x11,
	0x10,
	0x10,
	0x00,
	0x00,
	0x01,
	0x01,
	0x11,
	0x11,
	0x14,
	0x25,
	0x26,
};

__pmem const struct IrCode curtisCode = 
{
	freq_to_timerval(38970),
	curtisTimes,
	curtisCodes
};

// Code 046 - Aiko, Citizen, Daewoo, Nikko, NTC, Portland, Teknika
__pmem const uint16_t aikoTimes[] = 
{
	61, 53,
	61, 170,
	470, 459,
	61, 4612,
	61, 9937,
	61, 0,
};

__pmem const uint8_t aikoCodes[] =
{
	0x20,
	0x11,
	0x00,
	0x00,
	0x00,
	0x11,
	0x00,
	0x00,
	0x01,
	0x11,
	0x10,
	0x00,
	0x00,
	0x00,
	0x01,
	0x11,
	0x13,
	0x21,
	0x42,
	0x15,
};

__pmem const struct IrCode aikoCode = 
{
	freq_to_timerval(37470),
	aikoTimes,
	aikoCodes
};

// Code 047 - Daewoo
__pmem const uint16_t daewoo2Times[] = 
{
	56, 52,
	108, 52,
	56, 106,
	56, 282,
	56, 2592,
	56, 13150,
	56, 0,
};

__pmem const uint8_t daewoo2Codes[] =
{
	0x32,
	0x10,
	0x00,
	0x43,
	0x20,
	0x00,
	0x00,
	0x53,
	0x20,
	0x00,
	0x00,
	0x60
};

__pmem const struct IrCode daewoo2Code = 
{
	freq_to_timerval(28670),
	daewoo2Times,
	daewoo2Codes
};

// Code 048 - Electrohome, GE, JC Penney, MGA, Mitsubishi
__pmem const uint16_t electrohomeTimes[] = 
{
	59, 57,
	59, 178,
	924, 231,
	924, 459,
	59, 4260,
	59, 9752,
	59, 0,
};

__pmem const uint8_t electrohomeCodes[] =
{
	0x30,
	0x00,
	0x01,
	0x00,
	0x01,
	0x11,
	0x10,
	0x11,
	0x11,
	0x11,
	0x10,
	0x11,
	0x10,
	0x00,
	0x01,
	0x00,
	0x04,
	0x25,
	0x26,
};

__pmem const struct IrCode electrohomeCode = 
{
	freq_to_timerval(38970),
	electrohomeTimes,
	electrohomeCodes
};

// Code 049 - Emerson, Sharp
__pmem const uint16_t emersonTimes[] = 
{
	54, 51,
	54, 163,
	908, 224,
	444, 446,
	54, 4204,
	54, 9767,
	54, 0,
};

__pmem const uint8_t emersonCodes[] =
{
	0x30,
	0x00,
	0x00,
	0x00,
	0x01,
	0x11,
	0x11,
	0x11,
	0x11,
	0x11,
	0x10,
	0x00,
	0x00,
	0x00,
	0x01,
	0x11,
	0x14,
	0x25,
	0x26,
};

__pmem const struct IrCode emersonCode = 
{
	freq_to_timerval(38970),
	emersonTimes,
	emersonCodes
};

// Code 050 - Fisher, MGA, Mitsubishi, Sears
__pmem const uint16_t fisherTimes[] = 
{
	282, 876,
	282, 2038,
	282, 0,
};

__pmem const uint8_t fisherCodes[] =
{
	0x01,
	0x10,
	0x01,
	0x01,
	0x10,
	0x20
};

__pmem const struct IrCode fisherCode = 
{
	freq_to_timerval(44330),
	fisherTimes,
	fisherCodes
};

/*
// Code 051 - Amplivision, Atlantic, Clatronic, Condor, Desnet, Formenti, 
// Hanseatic, Korting, Manesth, NEC, Orion, Otto Versand, 
// Pathe Cinema, Perdio, Phoenix, Sogera, Soundwave, Standard, 
// Technema, Telemeister, Televideon, Tensai, Tenson, Uher,
// Videotechnic, Vision, Watson, Weltblick, White Westinghouse
__pmem const uint16_t amplivisionTimes[] = 
{
	3, 19,
	14, 19,
	71, 19,
	3, 29,
	48, 29,
	3, 13072,
	3, 0,
};

__pmem const uint8_t amplivisionCodes[] =
{
	0x32,
	0x45,
	0x31,
	0x00,
	0x01,
	0x46,
}
__pmem const struct IrCode amplivisionCode = 
{
	freq_to_timerval(8860),
	amplivisionTimes,
   amplivisionCodes
};
*/

// Code 052 - GE, JC Penney, JVC, Midland, Panasonic, Prism, Quasar, 
// Techics, Techwood
__pmem const uint16_t geTimes[] = 
{
	83, 89,
	83, 260,
	369, 339,
	83, 3849,
	83, 0,
};

__pmem const uint8_t geCodes[] =
{
	0x20,
	0x00,
	0x00,
	0x00,
	0x00,
	0x01,
	0x11,
	0x11,
	0x11,
	0x11,
	0x11,
	0x03,
	0x20,
	0x00,
	0x00,
	0x00,
	0x00,
	0x01,
	0x11,
	0x11,
	0x11,
	0x11,
	0x11,
	0x04,
};

__pmem const struct IrCode geCode = 
{
	freq_to_timerval(54160),
	geTimes,
	geCodes
};

// Code 053 - JVC
__pmem const uint16_t jvc2Times[] = 
{
	59, 57,
	59, 178,
	924, 231,
	924, 459,
	59, 4260,
	59, 9752,
	59, 0,
};

__pmem const uint8_t jvc2Codes[] =
{
	0x30,
	0x01,
	0x00,
	0x01,
	0x11,
	0x10,
	0x11,
	0x10,
	0x00,
	0x00,
	0x11,
	0x00,
	0x01,
	0x11,
	0x00,
	0x11,
	0x14,
	0x25,
	0x26,
};

__pmem const struct IrCode jvc2Code = 
{
	freq_to_timerval(38970),
	jvc2Times,
	jvc2Codes
};

// Code 054 - JVC
__pmem const uint8_t jvc3Codes[] = 
{
	0x31,
	0x11,
	0x01,
	0x10,
	0x00,
	0x00,
	0x10,
	0x01,
	0x10,
	0x10,
	0x01,
	0x00,
	0x01,
	0x01,
	0x10,
	0x11,
	0x14,
	0x25,
	0x26,
};

__pmem const struct IrCode jvc3Code = 
{
	freq_to_timerval(38970),
	jvc2Times,
	jvc3Codes
};

// Code 055 - Kloss Novabeam, Magnavox, Philco, Philips, Sylvania, Wards
__pmem const uint16_t klossTimes[] = 
{
	53, 237,
	53, 524,
	53, 812,
	53, 2959,
	53, 0,
};

__pmem const uint8_t klossCodes[] =
{
	0x02,
	0x02,
	0x02,
	0x01,
	0x10,
	0x00,
	0x01,
	0x30,
	0x20,
	0x20,
	0x20,
	0x11,
	0x00,
	0x00,
	0x14,
};

__pmem const struct IrCode klossCode = 
{
	freq_to_timerval(54070),
	klossTimes,
	klossCodes
};

__pmem const uint8_t num_codes = 55;

__pmem const struct IrCode *powerCodes[55] = 
{
	&sonyCode,
	&rcaCode,
	&panasonicCode,
	&sharpCode,
	&toshibaCode,
	&philipsCode,
	&samsungCode,
	&zenithCode,
	&pioneerCode,
	&sylvaniaCode,
	&jvcCode,
	&hitachiCode,
	&sampoCode,
	&hisenseCode,
	&viewsonicCode,
	&bushCode,
	&aocCode,
	&bellCode,
	&pioneer2Code,
	&fujitsuCode,
	&goldstarCode,
	&daewooCode,
	&NECCode,
	&admiralCode,
	&sony2Code,
	&viewsonic2Code,
	&zenith2Code,
	&thompsonCode,
	&brillianCode,
	&magnavoxCode,
	&viewsonic3Code,
	&crownCode,
	&hitachi2Code,
	&fujitsu2Code,
	&hitachi3Code,
	&NEC2Code,
	&hitachi4Code,
	&anamCode,
	&aoc2Code,
	&candleCode,
	&contecCode,
	&contec2Code,
	&sony3Code,
	&alleronCode,
	&contec3Code,
	&curtisCode,
	&aikoCode,
	&daewoo2Code,
	&electrohomeCode,
	&emersonCode,
	&fisherCode,
//	&amplivisionCode,
	&geCode,
	&jvc2Code,
	&jvc3Code,
	&klossCode,
};

//bytes_in:  9024
//bytes_out: 2543
